import sys
import os
import os.path

config_dic = {
    "source_dir" : os.path.join(os.environ['STRUSTER'],'SRC'),
    "log_file"   : 'job_compile_maps.rpt',
    "pdbsws_file": '/home/doming/WORK/DATA/PDBSWS/20070219/pdbsws_res.txt',
    "stmap_dir"  : '.'
    }


# import struster modules
sys.path.append(config_dic['source_dir'])

import log_util
import pdbsws_map

# start logging to the log_file
log_util.log_to_file(config_dic['log_file'])

try:
    pdbsws_obj = pdbsws_map.PDBSwsMap(config_dic['pdbsws_file'], config_dic['stmap_dir'])
    pdbsws_obj.compile_stmaps()
except:
    log_util.log_error('Failed to compile pdbsws maps')

# finish logging
log_util.close_log()
