import sys
import os
import os.path


config_dic = {
    "source_dir" : os.path.join(os.environ['STRUSTER'],'SRC'),
    "log_file"   : 'job_uniprot_pdbsws.rpt',
    "pdbswsmap_file": '/home/doming/WORK/DATA/PDBSWS/20070219/pdbsws_res.txt',
    "seqdb_lst" : ['/home/doming/WORK/DATA/UNIPROT/20070215/uniprot_sprot.fasta', '/home/doming/WORK/DATA/UNIPROT/20070215/uniprot_trembl.fasta'],
    "fasta_dir" : '/home/doming/WORK/STRUSTER/V_3_1/UNIPROT_PDBSWS/SEQ'
}

# import struster modules
sys.path.append(config_dic['source_dir'])

import log_util
import pdbsws_map

# start logging to the log_file
log_util.log_to_file(config_dic['log_file'])

pdbsws_map.get_pdb_fasta(config_dic['pdbswsmap_file'], config_dic['seqdb_lst'], config_dic['fasta_dir'])

# finish logging
log_util.close_log()
