# Copyright 2007 Max-Planck-Institut Informatik
# 
#     This file is part of STRuster.
# 
#     STRuster is free software; you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation; either version 2 of the License, or
#     (at your option) any later version.
# 
#     STRuster is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU General Public License
#     along with STRuster; if not, write to the Free Software
#     Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
#
# Contact:
#     Francisco S. Domingues
#     email: doming@mpi-sb.mpg.de



import shutil
import os

import log_util

def multiprot(sp_sunid, pdb_dir, scop_file):
    file_obj = file(scop_file, 'r')
    lines = file_obj.readlines()
    file_obj.close()
    sid_lst = []
    reading_sp = 0
    for line in lines:
        if len(line.strip()) == 0 or line.strip()[0] == '#' :
            continue
        line_lst = line.split()
        sunid_lst = line_lst[5].split(',')
        l_sp_sunid = sunid_lst[5]
        l_sp_sunid = l_sp_sunid[3:]
        if sp_sunid == l_sp_sunid:
            sid = line_lst[0]
            sid_lst.append(sid)
            reading_sp = 1
        elif reading_sp == 1:
            break

    astral_str = ''
    for sid in sid_lst:
        pdb_subdir = sid[2:4]
        astral_f =  sid + ".ent"
        orig_f = pdb_dir + '/' +  pdb_subdir + "/" + astral_f
        shutil.copy(orig_f, '.')
        astral_fname = model_filter(astral_f)
        astral_str =  astral_str + astral_fname + " "


    mult_cmd = 'multiprot.Linux ' + astral_str
    log_util.log_info(mult_cmd)
    os.system(mult_cmd)

    nr_funits = len(sid_lst)
    multp_file = str(nr_funits) + "_sol.res"
    pdb_cmd = 'corresp_pdb.pl ' + multp_file + ' ' + str(0)
    log_util.log_info(pdb_cmd)
    os.system(pdb_cmd)
    


def model_filter(astral_f):

    file_obj = file(astral_f, 'r')
    lines = file_obj.readlines()
    file_obj.close()

    has_model = 0
    for line in lines:
        if line[:5] == 'MODEL':
            has_model = 1
            break

    if has_model == 0:
        return astral_f
    else:
        new_astral_f = astral_f[:-4] + "m0" + '.ent'
        file_obj = file(new_astral_f, 'w')
        model_nr = 0
        for line in lines:
            if model_nr == 0:
                if line[:5] == 'MODEL':
                    model_nr = 1
                else:
                   file_obj.write(line)
            elif model_nr == 1:
                if line[:5] == 'MODEL':
                    break
                elif line[:6] == 'ENDMDL':
                    continue
                else:
                    file_obj.write(line)
        file_obj.close()
        return new_astral_f
