"""
Utilities for R
"""

# Copyright 2007 Max-Planck-Institut Informatik
# 
#     This file is part of STRuster.
# 
#     STRuster is free software; you can redistribute it and/or modify
#     it under the terms of the GNU General Public License as published by
#     the Free Software Foundation; either version 2 of the License, or
#     (at your option) any later version.
# 
#     STRuster is distributed in the hope that it will be useful,
#     but WITHOUT ANY WARRANTY; without even the implied warranty of
#     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#     GNU General Public License for more details.
# 
#     You should have received a copy of the GNU General Public License
#     along with STRuster; if not, write to the Free Software
#     Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
#
# Contact:
#     Francisco S. Domingues
#     email: doming@mpi-sb.mpg.de



import os
import rpy

import log_util



def source_r_clustering(source_dir):
    r_file = os.path.join(source_dir, 'clustering.R')
    rpy.r.source(file = r_file)
    
def source_r_plots(source_dir):
    r_file = os.path.join(source_dir, 'make_plots.R')
    rpy.r.source(file = r_file)

    
def save_obj_r(obj, obj_file):
    """
    Write object in R
    """
    rpy.r.saveobj(robj = obj, robjfile = obj_file)
    log_util.log_info('Saved %s' % obj_file)
        